// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//     mcr.dll v2.4 (windows)
// 12.11.2004 by Dim	http://macrocosm.narod.ru/madown.html
//  Delphi 5 -   DLL
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    FndBtn: TButton;
    Edit1: TEdit;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    Nload: TMenuItem;
    Nupload: TMenuItem;
    NS: TMenuItem;
    NBGH: TMenuItem;
    NFind: TMenuItem;
    N6: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure NloadClick(Sender: TObject);
    procedure NuploadClick(Sender: TObject);
    procedure NFindClick(Sender: TObject);
    procedure NBGHClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


// * * * CONST * * * //
const  MAX_WORD_LEN=32; //   
const  MAX_PARA_COUNT=200; //    

// * * * (1.0)   __        * * *  //
      type TWstr=record
        anword: array[0..MAX_WORD_LEN-1] of char; // ,    ++  PChar
        cid:byte;     //  
        vid:byte;    //  
        virt:char;  //    ~
        para:byte; //   -   
        end;

// * * * (1.1)             * * *//
      type TWs=record
        inlex:array[0..MAX_PARA_COUNT-1] of TWstr;
        count:integer;  //
        end;
      pTWs=^TWs; //pointer

// * * * (2.0) C     * * *//
      type Tid=record
        lnk:longword; //   ( 20 )
        en:byte;    //   (8 )    ed:=0
        end;

// * * * (2.1)    * * *//
      type Tids=record
        ids:array[0..MAX_PARA_COUNT-1] of Tid;
        count:integer;
        end;
        pTids=^Tids; //pointer
        pInt=^integer;

var
  Form1: TForm1;
  tmpID:integer;
// EXTERNAL DATA
// * * *   mcr.dll

//  
   function InitMcr: Integer; stdcall; cdecl; external '..\MCR.DLL' name 'InitMcr';

//   (path)
   function LoadMcr(const path:PChar): Integer; stdcall; cdecl; external '..\MCR.DLL' name 'LoadMcr';

//   (path)
function SaveMcr(const path:PChar): Integer; stdcall; cdecl; external '..\MCR.DLL' name 'SaveMcr';

//    s      Tids
function FindWID(const s:PChar; p:pTids): Integer; stdcall; cdecl; external '..\MCR.DLL' name 'FindWID';

//    TWs       
        // all=true -    (   ReadOnly )
        // gh_only=true -    
function GetBId(const lnk:integer; en:byte;gh_only,all:boolean;p:pTWs): Integer; stdcall; cdecl; external '..\MCR.DLL' name 'GetBid';

//      (   ReadOnly )
        //lnk -  
        //const_gh -     (const_gh=0 - )
        //var_gh -  . 
        //all=false -     
function GetBgh(const lnk:integer; const_gh:byte; var_gh:byte; all:boolean; p:pTWs): Integer; stdcall; cdecl; external '..\MCR.DLL' name 'GetBGH';


//   . a1,a2,a3        100%,    
function FreeSpace(a1,a2,a3:pInt): Integer; stdcall; cdecl; external '..\MCR.DLL' name 'FreeSpace';

//      ,  ReadOnly      ,   .-  
function RODict: boolean; stdcall; cdecl; external '..\MCR.DLL' name 'ReadOnlyDict';

//  
function GetVer: PChar; stdcall; cdecl; external '..\MCR.DLL' name 'Ver';

// 
function AddPara(outdata: pTWs): integer; stdcall; cdecl; external '..\MCR.DLL' name 'AddParadigma';


//     (byte)  . TWstr
//         
function CTS(const constid:byte):PChar; stdcall; cdecl; external '..\MCR.DLL' name 'ConstIdToStr';
function VTS(const constid,varid:byte):PChar; stdcall; cdecl; external '..\MCR.DLL' name 'VarIdToStr';


implementation

{$R *.DFM}


procedure say(s:string);
begin
Form1.Memo1.Lines.Add(s);
end;

procedure TForm1.NloadClick(Sender: TObject);
var
rc:integer;
dir:string;
begin
 //Hint:     
 dir:='../zal.mcr';
 InitMcr;
 rc:=LoadMcr(PChar(dir));
if rc<=0 then
begin
 ShowMessage('  .  '+IntToStr(rc))
 end
else
begin
 say('Ready');
 Nload.Enabled:=false;
// InitBtn.Enabled:=false;
 FndBtn.Enabled:=true;
 end;

end;

procedure TForm1.NuploadClick(Sender: TObject);
 var f:textfile;
 fn,s,ps:string;
 outdata:TWs;
 i,p,rc,j:integer;
begin
fn:='../mydict.txt';  //  
if not fileexists(fn) then
begin
ShowMessage(' :'+fn+ '  ');
exit;
end;

// 
InitMcr;

AssignFile(f,fn);
Reset(f);
 outdata.count:=0;
while (not Eof(f)) do
begin
 Readln(f,s);

 if (s='') then
 begin
  rc:=AddPara(@outdata); // 
  if (rc<0) then say('AddError rc='+IntToStr(rc));
  outdata.count:=0;
 end
 else
 if (s[1]<>#9) then // 
      begin
         if (s[1]='~') then
         begin
         outdata.inlex[outdata.count].virt:='~'; // 
         Delete(s,1,1);
         end;

         p:=Pos(#9,s); //
         ps:=Copy(s,1,p-1);
         strcopy(outdata.inlex[outdata.count].anword,PChar(ps));
         Delete(s ,1,p);

         p:=Pos(#9,s); // 
         outdata.inlex[outdata.count].cid:=StrToInt(Copy(s,1,p-1));
         outdata.inlex[outdata.count].vid:=StrToInt(Copy(s,p+1,length(s)));
         inc(outdata.count);
         if (outdata.count>=200) then
         begin
         say('Error incount>=200');
         dec(outdata.count);
         end;
         
      end;
end;
CloseFile(f);
Say('Upload ok');
 FndBtn.Enabled:=true;
 Edit1.text:=''; //,  
 NFindClick(self);
 NBGH.Enabled:=true;
  NFind.Enabled:=true;
end;

procedure TForm1.NFindClick(Sender: TObject);
var
s,s1:string;
count,i,rc:integer;
Uid :Tids;
WData:TWs;
cstr,vstr:array[byte] of char;
begin
         tmpId:=0;
         s:=Edit1.Text;
         count:=FindWID(PChar(s),@Uid);
         say('  "'+s+'"  : ' +IntToStr(count));
         for i:=0 to Uid.count-1 do
         begin
                rc:=GetBid(uid.ids[i].lnk,uid.ids[i].en,false,false,@WData);
                if rc>=0 then
                begin
                 strcopy(cstr,CTS(WData.inlex[0].cid));
                 strcopy(vstr,VTS(WData.inlex[0].cid,WData.inlex[0].vid));
                 if tmpId<>uid.ids[i].lnk then
                    begin
                     s1:=': '+StrPas(WData.inlex[0].anword);
                      say('');
                       end
                         else s1:='';
                 tmpId:=uid.ids[i].lnk;
                 say(s1);
                 s1:=#9+'* '+StrPas(cstr)+#9+StrPas(vstr);
                 say(s1);
                end
                else  say('Err:'+Inttostr(rc));
         end;
 NBGH.Enabled:=true;
end;


procedure TForm1.NBGHClick(Sender: TObject);
var
s,s1:string;
count,i,rc:integer;
Uid :Tids;
WData:TWs;
cstr,vstr:array[byte] of char;
 begin
         count:=GETBGH(tmpId,0,2,true,@WData);
         if count<0 then begin say('Err:'+Inttostr(rc)); exit; end;

         say('');
         say('(*       (0,2)*)');
         say('    : '+IntToStr(tmpId));
         say('    : 0,2 ( .   .. . )');
         say('    : ' +IntToStr(count));
         for i:=0 to count-1 do
         begin
                 s:=Strpas(WData.inlex[i].anword);
                 strcopy(cstr,CTS(WData.inlex[i].cid));
                 strcopy(vstr,VTS(WData.inlex[i].cid,WData.inlex[i].vid));
                 s1:=#9+s+#9+'* '+StrPas(cstr)+#9+StrPas(vstr);
                 say(s1);
         end;

end;

end.
