// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
//     mcr.dll v2.4 (windows)
// 12.10.2004 by Dim	http://macrocosm.narod.ru/madown.html
//   Visual Studio (console application)
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

#include <stdio.h> 
#include <fcntl.h>
#include <sys/stat.h>
#include <io.h>
#include <windows.h>

unsigned long tmplink=0;
const unsigned char MAX_WORD_LEN=32;//   
const unsigned char MAX_WORD_COUNT=200;//    


// ***           *** //


struct Tinlex
{
	char anword[MAX_WORD_LEN];//
	unsigned char cid,vid;  //    	
	char virt;            //optiaonlity of word //    ~ 
	unsigned char para;  //   -   
	
};

// ***         () ***//
struct Tinlexdata
{
Tinlex inlex[MAX_WORD_COUNT];
int count; //
};


// *** C    (UIN)  __  ***//
struct Tid
{
unsigned long lnk; //   ( 20 )
unsigned char en;  //     
};

// ***     ***//
struct Tids
{
Tid ids[MAX_WORD_COUNT];         //lixema uin+ending no
int count;//
};


	//*************************************************
	//				        DLL  
	//*************************************************

	// InitMcr() -   mcr
    typedef int (*p1Func)();
	p1Func pInit;	

	// LoadMcr -   mcr
    typedef int (*p2Func)(const char * s);
	p2Func pLoad;

	// SaveMcr -   mcr
    typedef int (*p3Func)(const char * s);
	p3Func pSave;
	
    // FindID -   s   mcr,  int     ids (   =    +    )
	//            
	typedef int (*p4Func)(const char * s, Tids * ids);
	p4Func pFind;

    // GetByID -   id,    ,      outdata
	// :: gh_only = true -    
	// :: gh_only = false -     id   (win1251)
    // :: all = true  -   wout     id   ,       ReadOnly
	typedef int (*p5Func)(const Tid id,bool gh_only, bool all,Tinlexdata * outdata);
	p5Func pGetBid;
	
    // ROnly      -     (ReadOnlyDict)
	typedef bool (*p6Func)(); 
	p6Func pROnly;

    // AddPara -    
	typedef int (*p7Func)(Tinlexdata * indata); 
	p7Func pAdd;

	//3Space -     ,       100%      
	typedef int (*p8Func)(unsigned char * ar1, unsigned char * ar2,unsigned char * ar3); 
	p8Func p3Space;

	//    mcr.dll
	typedef int (*p9Func)(char * s); 
	p9Func pVer;

	//   
	typedef char * (*p10Func)(const unsigned char cid); 
	p10Func pCTS;

	//   
	typedef char * (*p11Func)(const unsigned char cid, const unsigned char vid); 
	p11Func pVTS;


    //      (   ReadOnly )
       //lnk -  
        //const_gh -     (const_gh=0 - )
        //var_gh -  . 
        //all=false -     
	typedef int (*p12Func)(const int lnk, unsigned char const_gh,unsigned char var_gh,const bool all, Tinlexdata * outdata);
	p12Func pBGH;
	
	//*************************************************
	//         
	//*************************************************

void say(char * s)
{
	char str[255];
	sprintf(str,"%s\n",s);
    CharToOem(str,str);
	printf(str);
}


	//*************************************************
	//        			        DLL  
	//*************************************************

HINSTANCE MDLL_HANDLE;

int LoadDLL(char * fn)
{

	say(" mcr.dll");    
	//  DLL
 	if((MDLL_HANDLE=LoadLibrary(fn))==NULL) 
	{
		say("DLL  ");
		return -1;
	} 
	else 
		say("DLL ");

pInit   =  (p1Func)GetProcAddress(MDLL_HANDLE,"InitMcr");      
pLoad   =  (p2Func)GetProcAddress(MDLL_HANDLE,"LoadMcr");      
pSave   =  (p3Func)GetProcAddress(MDLL_HANDLE,"SaveMcr");      
pFind   =  (p4Func)GetProcAddress(MDLL_HANDLE,"FindWID");
pGetBid =  (p5Func)GetProcAddress(MDLL_HANDLE,"GetWordById");
pROnly  =  (p6Func)GetProcAddress(MDLL_HANDLE,"ReadOnlyDict");      
pAdd    =  (p7Func)GetProcAddress(MDLL_HANDLE,"AddParadigma");      
p3Space =  (p8Func)GetProcAddress(MDLL_HANDLE,"FreeSpace");      
pVer    =  (p9Func)GetProcAddress(MDLL_HANDLE,"Ver");      
pCTS    = (p10Func)GetProcAddress(MDLL_HANDLE,"ConstIdToStr");      
pVTS    = (p11Func)GetProcAddress(MDLL_HANDLE,"VarIdToStr");      
pBGH    = (p12Func)GetProcAddress(MDLL_HANDLE,"GetBGH");      

if (!(pInit  &&  pLoad && pSave && pFind && pGetBid && pAdd && p3Space && pROnly && pVTS && pCTS &&pBGH ))
{
	say("   DLL");
	FreeLibrary(MDLL_HANDLE);
	return -1;
} 
else 
    return 0;
}


void FreeDLL()
{
	FreeLibrary(MDLL_HANDLE);
}


	//*************************************************
	//           	 /     
	//*************************************************
int LoadMCR(char * fn)
{
	int rc;
    char outstr[255];
	  //    	//(*pInit)(); 
	 //    
     if ( ( rc = (*pLoad)(fn) ) <=0)     
	 {
		 say("  "); 		 
		 return -1;
	 }
		//
		(*pVer)(outstr);
		 say(outstr); 					

	 if ( (*pROnly)() )  say("    "); 
	 return 0;
	 
}

int SaveMCR(char * fn)
{
	int rc;

	say("  mcr"); 
     if ( ( rc = (*pSave)(fn) ) <=0)     
	 {
		 say("  "); 
		 switch (rc)
		 {
			 case -1:say("  "); 
				break;
			 case -2:say("  "); 
				break;
		 	 case -3:say("   ReadOnly"); 
				break;

		 }
		 return -1;
	 }
	 say(""); 
	 return 0;
}


	//*************************************************
	//            					     
	//*************************************************

int FindMyWord(char * s)
{
	int rc,i,count;
	char instr[MAX_WORD_LEN],outstr[255];
    Tids Uids; //
	Tinlexdata wout;

	 say("_________________________________");
		 strcpy(instr,s);         
		 sprintf(outstr,"  '%s'",instr);
		 say(outstr);
		 say("_________________________________");
		 say(" ) -   []");
		 say("");
		 //126 =   

		//    
		 count=(*pFind)(instr, &Uids); 
		 if (count<=0)
		 {
			 switch (count)
			 {
				case  0:   say("  ");
				 break;
				case -1:   say("   ");
				 break;
				case -128: say("  ");
				 break;
			 }
			 
		 }
		  else		  
		 for (i=0;i<count;i++)
		 { 

            //         
			//   wout.inlex[0]     
		    rc=(*pGetBid)(Uids.ids[i],false,false,&wout);
			
			//        
			
		   if (i>0) if (Uids.ids[i].lnk==Uids.ids[i-1].lnk) wout.inlex[0].anword[0]=0;

			//     
		   if (rc>0) 
		   {   // (*pCTS) -      .
			    sprintf(outstr,"%i)%s - %s\t%s [%i]",i+1,wout.inlex[0].anword,(*pCTS)(wout.inlex[0].cid),(*pVTS)(wout.inlex[0].cid,wout.inlex[0].vid), wout.inlex[0].virt);
				say(outstr);
		   }
		   else
		   {			
			 switch (rc)
			 {
				case  -1: say("Read Only Dict");
				 break;
				case  -2:
				case  -3: say("Bad uid");
				 break;				
			 }
		   }

		 }
		 
		 say("_________________________________");

		 return 0;

}


int ShowParadigm(char * s)
{ 
	int rc,i,j,count;
	char instr[MAX_WORD_LEN],outstr[255];
    Tids Uids; //
	Tinlexdata wout;

	 say("_________________________________");
		 strcpy(instr,s);         
		 sprintf(outstr,"  '%s'",instr);
		 say(outstr);
		 say("_________________________________");
		 say(" ) -   []");
		 say("");
		 //126 =   

		//    
		 count=(*pFind)(instr, &Uids); 
		 if (count<=0)
		 {
			 switch (count)
			 {
				case  0:   say("  ");
				 break;
				case -1:   say("   ");
				 break;
				case -128: say("  ");
				 break;
			 }
			 
		 }
		  else		  
		 for (i=0;i<count;i++)
		 { 

            //          
			//   wout
			//         ReadOnly
		    rc=(*pGetBid)(Uids.ids[i],false,true,&wout);

			//   ,        
		    if (i>0) if (Uids.ids[i].lnk==Uids.ids[i-1].lnk) rc=0;

			 tmplink=Uids.ids[i].lnk;
		    //     
		   if (rc>0) 
		   {
			   for (j=0;j<wout.count;j++)
			   {
			    sprintf(outstr,"%i)%s - %s\t%s [%i]",j+1,wout.inlex[j].anword,(*pCTS)(wout.inlex[j].cid),(*pVTS)(wout.inlex[j].cid,wout.inlex[j].vid), wout.inlex[j].virt);
				say(outstr);
			   }
		   }
		   else
		   {			
			 switch (rc)
			 {
				case  -1: say("Read Only Dict");
				 break;
				case  -2:
				case  -3: say("Bad uid");
				 break;				
			 }
		   }

		 }
		 
		 say("_________________________________");

		 return 0;

}

int GetWBGH(unsigned long link, unsigned char const_gh,unsigned char var_gh)
{ 
	int i,count;
	char outstr[255];   
	Tinlexdata wout;

		 
		 sprintf(outstr,"     ");
		 say(outstr);		 
		 sprintf(outstr,"ID: %i, Const: %i, Var: %i",link,const_gh,var_gh);
		 say(outstr);

		 count=(*pBGH)(link, const_gh,var_gh,true, &wout); 
		 if (count<=0)
		 {
			 switch (count)
			 {
				case  0:   say("  ");
				 break;
				case -1:   say("   ");
				 break;
				case -128: say("  ");
				 break;
			 }
			 
			 return -1;
		 }
	  
		 for (i=0;i<count;i++)
		 { 
		    sprintf(outstr,"%i)%s - %s\t%s [%i]",i+1,wout.inlex[i].anword,(*pCTS)(wout.inlex[i].cid),(*pVTS)(wout.inlex[i].cid,wout.inlex[i].vid), wout.inlex[i].virt);
				say(outstr);
		 }		   

		 
		 say("_________________________________");

		 return 0;

}


	//*************************************************
	//            		   
	//*************************************************

int UploadFromTxt(char * fn)
{
	FILE *stream;
	char buf[100];
	Tinlexdata wout;
	int rc;

	
	 	 
	 stream = fopen(fn,"r");// 
     if (stream == NULL){
             say("    \n");
             return -1;
        }
	say(" ");
     (*pInit)();// 

	  wout.count=0;
	//          Tinlexdata
	  while (fgets (buf, MAX_WORD_LEN+5, stream) != NULL) 
	  {
	   wout.inlex[wout.count].virt=0;
	   if (buf[0]!=9) //  
	   {
       
	     if ((rc=sscanf(buf,"%s\t%i\t%i", wout.inlex[wout.count].anword, &wout.inlex[wout.count].cid, &wout.inlex[wout.count].vid)) == 3)
		 {

	   	  if (wout.inlex[wout.count].anword[0]=='~')//~   ,    virt
		   {
			wout.inlex[wout.count].virt='~';
			strcpy(wout.inlex[wout.count].anword,wout.inlex[wout.count].anword+1);//  ~			
		   }
		  wout.count++;

		 }
		 else 
		 {
			 rc=(*pAdd)(&wout);//   
			 wout.count=0;
			 if (rc>=0) say(".");
			 else			 
			 switch (rc)
			 {
				 case  -1:
				 case  -2:
				 case  -3:
				 case  -4:
				 case  -5:
					 say("  ");
					 break;
				 case  -6:	
					 say("    ");
					 break;
				 case  -9:   say(" ");
					 break;
				 case -10:   say("  ");
					 break;					 
			 }
		 }

	   }
	  } //~while

	  fclose (stream);// 	  
	  return 0;
}

	//*************************************************
	//            								   MAIN
	//*************************************************

int main(int argc, char* argv[])
{	//Hint     	
	
	if (LoadDLL("../mcr.dll")<0) 
		return -1;

	if (LoadMCR("../zal.mcr")<0) //  
	{
		FreeDLL();
		return -2;
	}

	 FindMyWord("");
	 FindMyWord("");


	 if (UploadFromTxt("../mydict.txt")>=0)
	 {
        ShowParadigm("");		
       //      .=2
	   //( .  .. . )
        GetWBGH(tmplink,0,2); 
        SaveMCR("../mydict.mcr");		
	 }
	 

   

    FreeDLL();
	return 0;
}


